%Clear all variables, close all windows
clear variables;close all;

%%
%Import Pictures
%Number of digits in the name of your pictures
counterdigits = 4;
filebody = 'D:\Store Your data here - never on C\JoVEesr\SamplePics\IMG_'; % Name of the files/the numbers have been generated atomatically
selectcroperegion = 0;%0;         % if 1 , for each sample, the first picture is displayed to select the area with blood for levelsearch.

%Initialisation and properties of all the samples to analyze in the frame sequence
FirstDexNo=9;%Samples with hemolysis, will require a different segmentation method
i=1;
s(i).imgInfos =strcat('S2_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 0; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round([630 456 468 3300]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('S2_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 1; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round([1056 576 408 3192]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 2; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round([2034 534 378 3228]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 2; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round([2364 528 348 3246]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('S2inT2_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 23; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round([3324 552 354 3228]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('S2inT2_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 23; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [3624 582 360 3144]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2inS2_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 24; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [3966 546 372 3216]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2inS2_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 24; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [4302 534 378 3252]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;

s(i).imgInfos =strcat('S2Dex55_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 19; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [1398 558 360 3174]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('S2Dex55_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 19; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [1710 558 372 3198]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2Dex55_1');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 21; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [2688 594 360 3198]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;
s(i).imgInfos =strcat('T2Dex55_2');%Automatic naming of the sample (if ordered from left to right)
s(i).firstframe = 21; %First frame number with the sample
s(i).lastframe =  999; %Last frame number with the sample
s(i).croppos = round( [2988 558 384 3186]*0.15);  % if you know the crop position already , [xmin ymin width height]
s(i).pixelpermm = 2041.67/100*0.15;         % ratio of pixel to mm, use first frame and get the height in pixel of a certain tube height in mm
i=i+1;

%% %%%%% start main program
for count=1:i-1  % loop over all samples
    filename = [filebody num2str(s(count).firstframe,['%0' num2str(counterdigits) 'u']) '.jpg' ]; %complete name of the first picture
    
    imexif = imfinfo(filename); disp([' Start measurement. ' , imexif.DateTime]);%get additional info from the pictures file
    tstart = datenum(imexif.DateTime,'yyyy:mm:dd HH:MM:SS'); % to calculate the duration in seconds
    %Be careful, the exact commands for extraction of metadata depend on
    %the file format!

    s(count).DateTimeStart = imexif.DateTime;%Get the time from the file
    if selectcroperegion %Use the manually selected crop region if required. 
        %I don't recommend this, the matlab interface is not as
        %user-friendly as the ImageJ interface and do not allow any error.
        im = imread(filename);
        figure(1);imagesc(im);axis equal;
        disp('select region for croping by double click in selected region');
        h = imrect(gca);
        croppos = round(wait(h));
        disp(['selected crop position: ', num2str(croppos) ' [xmin ymin width height]']);
        s(count).croppos=croppos;
    end
%%
    s(count).levels = [];   % the table for the extracted levels
    for framenumber=s(count).firstframe:s(count).lastframe %Loop on each picture
        
        filename = [filebody num2str(framenumber,['%0' num2str(counterdigits) 'u']) '.jpg' ];
        %actual name of the current picture
        disp(['current img:' filename]);%Shows the current state of analysis
        %get file info
        imexif = imfinfo(filename); 
        disp(imexif.DateTime);
        tmeas = 24*3600*(datenum(imexif.DateTime,'yyyy:mm:dd HH:MM:SS') - tstart); % calculate the duration since start in seconds
        %Read and crop picture
        im = imread(filename);
        im=imcrop(im,s(count).croppos);   
        %Extract each color channel
        im1= im(:,:,1);im2= im(:,:,2);im3= im(:,:,3);
        
        
        %ColorThresholding, favoring red pixels
        BinIm=2*im1+510-im2-im3;
        T=1.6*graythresh(BinIm);%Threshold used if hemolysis in the samples. Depending on the background and light, this might need to be adjusted.
        if count>=FirstDexNo
            BinIm=imbinarize(BinIm,T);
        else
            BinIm=imbinarize(BinIm);
        end
        %Average the intensity on the horizontal direction, and smooth the
        %data (on approx. 1mm)
        immean=mean(BinIm,2);
        immocmed=movmedian(immean,50);
   %array for abscissa in millimeters
    xpos = (1:length(immocmed))';
    
    
    pks = max(immocmed); %Find max value in the intensity profile
    locs=find(transpose(immocmed) == pks);%find all the locations
    mins=min(immocmed);%Find minimal value
    lo=find(transpose(immocmed) == mins);%Andall their locations
    %Ensure that the maximum considered for the transition is after a minimum
    %(useful when you have bubbles or too small pictures)
    for idx=1:size(locs,2)
        if locs(idx)>lo(1)
            Idx=idx;
            break
        end
    end
    %Compute changes in intensities , between the first
    %minimum and the next first maximum of the intensity
    [maxDiff,location]=max(diff(immocmed(1+lo(1):min([1+locs(Idx),size(immocmed,1) ]))));
    %the surface is where you have maximum change
    level = (location+1+lo(1))/s(count).pixelpermm;
    
    s(count).levels = [ s(count).levels ; tmeas , level];%Store the result
    disp(['pos-level=' num2str(level) 'mm']);%Show it
    end
end
%Show and save the data for each sample
for count=1:i-1
    %Show data
    h=figure; 
    plot(s(count).levels(:,1)/60,s(count).levels(:,2)-s(count).levels(1,2),'b.'); hold all;
    xlabel('time in minutes');ylabel('sedimentation distance in mm');
    %Save the final picture
    OutPic=strcat(filebody,s(count).imgInfos,'.jpg');
    print(h,'-djpeg',OutPic);
    %Save the data
    Outfilename=strcat(filebody,s(count).imgInfos,'.txt');
    fout=fopen(Outfilename,'w');
    fprintf(fout,'%f\t%f\n',transpose(s(count).levels));
    fclose('all');
end